function RuanmeiJsFunctions() {
    var that = this,
        UA = navigator.userAgent,
        isAndroid = /(Android)/i.test(UA),
        isIOS = /(iPhone|iPad|iPod|iOS)/i.test(UA),
        isUWP = /(uwpclient)/i.test(UA),
        isMac = /(Macintosh)/i.test(UA),
        isCatalyst = /(\/catalyst\/)/i.test(UA),
        isWin = /(Windows NT)/i.test(UA),
        isNative = /(\/native\/)/i.test(UA),
        useNewInit = /(\/rmsdklevel2\/)/i.test(UA),
        tRes = (UA + " ").match(/ (ithome|lapin|ggUnionClient|taofuli|mytime|zuihuimai)\S*\/(\d+\.\d+)\s+/) || ["/-1", "unknown", "-1"],//添加App修改1
        pIdx = tRes[2].indexOf("."),
        appStr = tRes[1],
        appver = parseFloat(pIdx === -1 ? tRes[2] : tRes[2].substring(0, pIdx + 1) + tRes[2].substring(pIdx + 1).replace(/\./g, "")),
        relation = {//添加App修改2：s简称、f全称、m最低支持版本号、t历史中使用过的框架（n:native,r:reactnative,f:flutter,e:electron）
            //统一约定：
            //1、页面打开时软件的夜间模式状态需要在UA中体现，夜间模式下，上述正则匹配的UA片段中需要包含/night/片段
            //2、如果软件在支持阶段中途更换过开发框架（native、reactnative、electron、flutter），那么需要在UA中体现出变更，以区分前后两种框架。
            //  例如，从native替换为reactnative，那么UA中需要包含/reactnative/片段；从reactnative切换为native，则UA中需要包含/native/。
            ithome: { s: "it", f: "ithome", m: 6.38, t: "n" },
            lapin: { s: "lp", f: "lapin", m: 3.63, t: "n" },
            ggUnionClient: { s: "ad", f: "adunion", m: 1.0, t: "n" },
            taofuli: { s: "tao", f: "taofuli", m: 1.0, t: "r" },
            mytime: { s: "mt", f: "mytime", m: 0.58, t: "n|r|e" },
            zuihuimai: { s: "zhm", f: "zuihuimai", m: 1.0, t: "n" },
            unknown: { s: "unknown", f: "unknown", m: 999, t: "n" }
        },
        isWkwebview = UA.indexOf("wkwebview") !== -1,
        isReactNative = (isAndroid || isIOS)
            && (/(\/reactnative\/)/i.test(tRes[0])//UA含reactnative则视为RN
                || (relation[appStr].t.indexOf("r") !== -1
                    && !/(\/native\/)/i.test(tRes[0])
                    && !/(\/flutter\/)/i.test(tRes[0]))),
        isElectron = UA.indexOf("Electron") !== -1,
        isCommonChannel = isElectron || (isWin && isNative),
        wxAppName = "unknown",
        sdkver = 2.70,
        allApiNames = [
            "canIUse",/*0*/ "closeWindow",/*1*/ "getSettings",/*2*/ "getUserInfo",/*3*/ "getUserHash",/*4*/
            "getSystemInfo",/*5*/  "setClipboardData",/*6*/  "getClipboardData",/*7*/  "navigateTo",/*8*/
            "redirectTo",/*9*/ "toast",/*10*/ "login",/*11*/ "hideMenus",/*12*/ "scanCode",/*13*/  "showMenus",/*14*/
            "share",/*15*/ "shareConfig",/*16*/ "showModal",/*17*/ "encrypt",/*18*/ "decrypt",/*19*/  "downloadFile",/*20*/
            "saveImageToPhotosAlbum",/*21*/ "onEvent",/*22*/ "previewImage",/*23*/ "hideToast",/*24*/ "showLoading",/*25*/
            "hideLoading",/*26*/ "getPushTags",/*27*/ "request",/*28*/ "addOrRemovePushTags",/*29*/ "showActionSheet",/*30*/
            "requestPayment",/*31*/"onPageVisibleChanged",/*32*/"showUpgradeTip",/*33*/"openKeyboard",/*34*/"canOpenURL",/*35*/
            "shareFile",/*36*/"getInstalledApps",/*37*/"copyFile",/*38*/"getLocation"/*39*/
        ],
        wxCanUse = [0, 15, 13, 1, 8, 9, 23, 19, 18, 11, 3, 4, 5, 28, 10],// 微信支持API
        normalApis = [2, 4, 6, 7, 10, 12, 14, 16, 17, 18, 19, 20, 21, 22, 24, 25, 26, 27, 29, 30, 31, 33, 35, 36, 37, 38, 39],// 常规API
        rnApis = [3, 4, 12, 14, 16, 11, 1, 8, 9, 2, 13, 15, 10, 16, 23, 25, 26, 32, 30],// RN支持API

        isReady = false,
        readyCallbacks = [],
        userInfo = {},
        hash = "",
        sysInfo = {},
        intent = null,
        bridgeInternal = null,
        errorMsg = "SDK initialization not finished, please wait.\n ",
        callNative = function (bridgename, data, callback) {
            if (callback != null) {
                var message = errorMsg;
                if ((isAndroid && !window._dsbridge) || (isIOS && !window.WebViewJavascriptBridge)) {
                    message += "-- Bridge status: not exist.\n "
                } else if ((isAndroid && !!window._dsbridge) || (isIOS && !!window.WebViewJavascriptBridge)) {
                    message += "-- Bridge status: has injected. \n"
                }
                callback({ success: false, message: message })
            }
        },
        _onPageVisibleChanged = null,
        _onAppThemeChanged = null,
        _optionMenuCB = null,
        _listeners = {},
        secret = "",
        encryptStr = function (m, k) {
            eval(secret);
            return { success: true, data: enc(m, k).toString() };
        },
        decryptStr = function (m, k) {
            eval(secret);
            return { success: true, data: dec(m, k).toString() };
        },
        textSelectable = false,
        rnCallbacks = {},
        rnLastCallbackId = 0;


    this.ready = function (callback) {
        if (isReady) {
            callback();
        } else {
            readyCallbacks.push(callback);
        }
    }
    normalApis.forEach(function (i) {
        var name = allApiNames[i];
        that[name] = function () {
            var args = getArgs(arguments);
            callNative(name, args[0], args[1]);
        }
    })

    this.openKeyboard = function (i) {
        callNative("openKeyboard", null, null);
        if (!!i) {
            setTimeout(function () { var e = document.getElementById(i); e && e.focus(); }, 300);
        }
    }

    this.bindNavigation = function (cb) {
        // if (that.isLegalEnv()) {
        //     if (!window.__rmNavLitener)
        //         window.__rmNavLitener = function (e) {
        //             if (e.target.hasAttribute("rm-nav")) {
        //                 var redirect = e.target.hasAttribute("redirect"),
        //                     sName = "href-" + relation[appStr].s + "-" + getPlat().toLowerCase().replace("/", "-"),
        //                     fName = "href-" + relation[appStr].f,
        //                     url = e.target.getAttribute(sName) || e.target.getAttribute(fName) || e.target.getAttribute("href");
        //                 if (!isEmpty(url)) {
        //                     if (url.indexOf("javascript:") == 0) {
        //                         eval(url.substring(11));
        //                     } else {
        //                         that[redirect ? "redirectTo" : "navigateTo"]({ url: url });
        //                     }
        //                 }
        //                 e.preventDefault();
        //             }
        //         };
        //     document.removeEventListener('click', window.__rmNavLitener, false);
        //     document.addEventListener('click', window.__rmNavLitener, false);
        // }
        // cb && cb({ success: that.isLegalEnv() })
    }

    this.sendMessage = function (data) {
        var callback = typeof arguments[1] === "function" ? arguments[1] : null;
        if ((isReactNative && data.proxyEnv !== "native") || isUWP || isCommonChannel) {
            if (isCommonChannel && !data.isInternalApi) {
                data = { name: "sendMessage", data: data };
            }
            if (callback != null) {
                data.callbackId = addRNCallback(callback, this);
            } else {
                data.callbackId = -1;
            }
            var finalData = isCommonChannel ? data : JSON.stringify({
                name: "SDK-sendMessage",
                message: JSON.stringify(data)
            })
            var bridgeName = isReactNative ? "ReactNativeWebView" : "UWPOrElBridge";
            window[bridgeName].postMessage(finalData);
        } else {
            callNative("sendMessage", data, callback);
        }
    }

    this.onReceiveMessage = function (name, listener) {
        _listeners[name] = listener;
    }

    this.config = function (data) {
        var pageAttr = data.pageAttr;
        if (typeof pageAttr !== typeof undefined) {
            textSelectable = !!pageAttr.textSelectable;
            that.setTextSelectEnable(textSelectable);
        }
        callNative("config", data, null)
    }
    this.isLegalEnv = function () {
        return (is("it") && isMac && appver >= 1.35)//IT之家MAC
            || appver >= relation[appStr].m
            || isWxmp();//小程序
    }
    this.setTextSelectEnable = function (enable) {
        textSelectable = enable;
        toggleCLass("body", !enable, "disable-user-select-ruanmei-sdk");
    }
    this.getEnv = function () {
        var app = relation[appStr].f;
        if (isWxmp()) {
            app = "wxmp";
        }
        var f = "unknown";
        if (that.isLegalEnv()) f = "native";
        if (isReactNative) f = "react native";
        if (isElectron) f = "electron";
        return {
            isLegal: that.isLegalEnv(),
            app: isWxmp() ? wxAppName : app,
            platform: getPlat(),
            appver: isWxmp() ? 6.60 : appver,
            sdkver: sdkver,
            isWxmp: isWxmp(),
            framework: f
        }
    }
    this.getSystemInfo = function () {
        var args = getArgs(arguments);
        callback = args[1];
        if (isWxmp()) {
            var data = {};
            data.isWxmp = isWxmp();
            data.platform = getPlat();
            callback({ success: true, systemInfo: data });
        } else {
            callNative("getSystemInfo", args[0], function (res) {
                if (typeof res.systemInfo !== typeof undefined) {
                    res.systemInfo.isWxmp = false;
                }
                callback(res);
            });
        }
    }
    this.getSystemInfoSync = function () {
        if (isWxmp()) {
            var data = {};
            data.isWxmp = isWxmp();
            data.platform = getPlat();
            return { success: true, systemInfo: data };
        } else {
            return sysInfo;
        }
    }
    this.getIntent = function () {
        return intent;
    }
    this.createOptionMenus = function (menus, cb) {
        _optionMenuCB = cb;
        callNative("createOptionMenus", menus, null);
    }
    this.login = function () {
        var args = getArgs(arguments);
        if (isWxmp() && userInfo.success) {
            return args[1](userInfo);
        }
        callNative("login", args[0], function (res) {
            userInfo = res;
            callNative("getUserHash", null, function (hashRes) {
                hash = hashRes;
                args[1](res);
            })
        });
    }
    this.getUserInfo = function () {
        var args = getArgs(arguments);
        if (isWxmp() && userInfo.success) {
            return args[1](userInfo);
        }
        callNative("getUserInfo", args[0], function (res) {
            userInfo = res;
            args[1](res);
        });
    }
    this.getUserInfoSync = function () {
        return userInfo;
    }

    this.getUserHashSync = function () {
        return hash;
    }

    this.share = function (data, callback) {
        if (isWxmp()) {
            wx.miniProgram.navigateTo({
                url: '/pages/tool/share?'
                    + convert2QueryString({ title: data.title, image: data.imgUrl, url: data.url })
            })
        } else {
            callNative("share", data, callback);
        }
    }
    this.scanCode = function (data, callback) {
        if (isWxmp()) {
            wx.scanQRCode({
                needResult: !!data.needResult,
                success: function (res) {
                    callback({ success: true, data: res.resultStr });
                }
            });
        } else {
            callNative("scanCode", data, callback);
        }
    }
    this.canIUse = function (data, callback) {
        if (isWxmp()) {
            var cannot = [];
            data.forEach(function (t) {
                if (wxCanUse.indexOf(allApiNames.indexOf(t)) == -1) {
                    cannot.push(t);
                }
            })
            callback({ success: cannot.length == 0, cannot: cannot });
        } else if (that.isLegalEnv()) {
            callNative("canIUse", data, function (res) {
                var result = res;
                if (isReactNative) {
                    result.cannot = result.cannot || [];
                    result.cannot = result.cannot.filter(function (item) {
                        return rnApis.indexOf(allApiNames.indexOf(item)) == -1;
                    })
                    result.success = result.cannot.length == 0;
                }
                callback(result);
            });
        } else {
            callback({ success: false, cannot: data });
        }
    }
    this.closeWindow = function () {
        if (isWxmp()) {
            wx.miniProgram.navigateBack({
                delta: 1
            })
        } else {
            callNative("closeWindow", null, null);
        }
    }


    this.onPageVisibleChanged = function (callback) {
        _onPageVisibleChanged = callback;
    }

    this.onAppThemeChanged = function (calback) {
        _onAppThemeChanged = calback;
    }

    this.request = function (data, callback) {
        var rq = {};
        var method = "GET";
        var url = getAbsolutePath(data.url);
        if (typeof data.method !== typeof undefined) {
            method = data.method.toUpperCase();
        }
        var header = data.header;
        var type = "content-type";
        var typeValue = "application/x-www-form-urlencoded";
        if (typeof header === typeof undefined) { header = {}; }
        if (typeof header[type] === typeof undefined) { header[type] = typeValue }
        var bodyData = null;
        if (method == "GET" || method == "HEAD") {
            var result = convert2QueryString(data.data);
            if (result.length > 0) url += (url.indexOf('?') !== -1 ? "&" : "?") + result;
        } else {
            bodyData = data.data;
            if (header[type] === "application/json") {
                bodyData = JSON.stringify(data.data);
            } else if (header[type] === typeValue) {
                bodyData = convert2QueryString(data.data);
            }
        }
        rq.method = method;
        rq.url = url;
        rq.header = header;
        rq.data = bodyData;
        var urlInfo1 = parseUrl(url);
        var urlInfo2 = parseUrl(window.location.href);
        if (urlInfo1.scheme == urlInfo2.scheme && urlInfo1.host == urlInfo2.host) {
            _ajax(rq, callback);
        } else {
            callNative(method == "HEAD" ? "requestHeader" : "request", rq, callback);
        }
    }
    this.navigateTo = function (data) {
        navTo("navigateTo", data);
    }
    this.redirectTo = function (data) {
        navTo("redirectTo", data);
    }
    function navTo(funName, data) {
        if (isWxmp()) {
            wx.miniProgram[funName]({
                url: "/pages/webview/webview?url=" + encodeURIComponent(data.url)
            })
        } else if (that.isLegalEnv()) {
            callNative(funName, { url: getTargetUrl(data), openExternal: !!data.openExternal, intent: data.intent }, null);
        } else {
            var link = document.createElement("a");
            link.href = data.url;
            if (funName == "navigateTo") {
                link.target = "_blank";
            }
            link.click();
        }
    }
    this.previewImage = function (data) {
        if (isWxmp()) {
            wx.previewImage({
                current: data.url,
                urls: data.imgUrls
            });
        } else {
            callNative("previewImage", data, null);
        }
    }

    this.encryptSync = function (data, callback) {
        return encryptStr(data.text, data.key);
    }

    this.decryptSync = function (data, callback) {
        return decryptStr(data.text, data.key);
    }

    if (isReactNative || isUWP) {
        // RN、UWP回调接收
        document.addEventListener('rnJsSdkCallback', function (e) {
            processRnOrElCallback(e.data);
        }, false);
    } else if (isCommonChannel) {
        // Electron、win32等通用回调接收
        window.__electronOnMessage = processRnOrElCallback;
    }

    if (!that.isLegalEnv() || isWxmp()) {
        doneBridge({});
    } else if (isAndroid) {
        // Android（原生、RN）通信方式
        var bridge = {
            default: this,
            call: function (method, args, cb) {
                var ret = '';
                if (typeof args == 'function') {
                    cb = args;
                    args = {};
                }
                var arg = { data: args === undefined ? null : args }
                if (typeof cb == 'function') {
                    var cbName = 'dscb' + window.dscb++;
                    window[cbName] = cb;
                    arg['_dscbstub'] = cbName;
                }
                arg = JSON.stringify(arg);

                if (window._dsbridge) {
                    ret = _dsbridge.call(method, arg);
                } else if (window._dswk || navigator.userAgent.indexOf("_dsbridge") !== -1) {
                    ret = prompt("_dsbridge=" + method, arg);
                }

                return JSON.parse(ret || '{}').data;
            },
            register: function (name, fun, asyn) {
                var q = asyn ? window._dsaf : window._dsf;
                if (!window._dsInit) {
                    window._dsInit = true;
                    setTimeout(function () {
                        bridge.call("_dsb.dsinit");
                    }, 0)
                }
                if (typeof fun == "object") {
                    q._obs[name] = fun;
                } else {
                    q[name] = fun;
                }
            },
            registerAsyn: function (name, fun) {
                this.register(name, fun, true);
            },
            hasNativeMethod: function (name, type) {
                return this.call("_dsb.hasNativeMethod", { name: name, type: type || "all" });
            },
            disableJavascriptDialogBlock: function (disable) {
                this.call("_dsb.disableJavascriptDialogBlock", {
                    disable: disable !== false
                })
            }
        };
        !function () {
            if (window._dsf) return;
            var ob = {
                _dsf: {
                    _obs: {}
                },
                _dsaf: {
                    _obs: {}
                },
                dscb: 0,
                dsBridge: bridge,
                close: function () {
                    bridge.call("_dsb.closePage");
                },
                _handleMessageFromNative: function (info) {
                    var arg = JSON.parse(info.data);
                    var ret = {
                        id: info.callbackId,
                        complete: true
                    }
                    var f = this._dsf[info.method];
                    var af = this._dsaf[info.method];
                    var callSyn = function (f, ob) {
                        ret.data = f.apply(ob, arg);
                        bridge.call("_dsb.returnValue", ret);
                    }
                    var callAsyn = function (f, ob) {
                        arg.push(function (data, complete) {
                            ret.data = data;
                            ret.complete = complete !== false;
                            bridge.call("_dsb.returnValue", ret);
                        })
                        f.apply(ob, arg);
                    }
                    if (f) {
                        callSyn(f, this._dsf);
                    } else if (af) {
                        callAsyn(af, this._dsaf);
                    } else {
                        var name = info.method.split('.');
                        if (name.length < 2) return;
                        var method = name.pop();
                        var namespace = name.join('.');
                        var obs = this._dsf._obs;
                        var ob = obs[namespace] || {};
                        var m = ob[method];
                        if (m && typeof m == "function") {
                            callSyn(m, ob);
                            return;
                        }
                        obs = this._dsaf._obs;
                        ob = obs[namespace] || {};
                        m = ob[method];
                        if (m && typeof m == "function") {
                            callAsyn(m, ob);
                            return;
                        }
                    }
                }
            }
            for (var attr in ob) {
                window[attr] = ob[attr];
            }
            bridge.register("_hasJavascriptMethod", function (method, tag) {
                var name = method.split('.');
                if (name.length < 2) {
                    return !!(_dsf[name] || _dsaf[name]);
                } else {
                    var method = name.pop();
                    var namespace = name.join('.');
                    var ob = _dsf._obs[namespace] || _dsaf._obs[namespace];
                    return ob && !!ob[method];
                }
            });
            registerJsFuns(bridge, "registerAsyn");
        }();

        doneBridge(bridge);
    } else if (isIOS || (isMac && !isElectron)) {
        // iOS(原生、RN)、macOS原生通信方式
        errorMsg = "SDK initialization Begin.\n";
        if (isReactNative && !window.ReactNativeWebView) {
            if (isWkwebview) {
                window.ReactNativeWebView = {
                    postMessage: function (data) {
                        window.webkit.messageHandlers.ReactNativeWebView.postMessage(String(data));
                    }
                };
            } else {
                (function () {
                    var messageQueue = [];
                    var messagePending = false;
                    function processQueue() {
                        if (!messageQueue.length || messagePending)
                            return;
                        messagePending = true;
                        document.location = 'react-js-navigation://ReactNativeWebView?' + encodeURIComponent(messageQueue.shift());
                    }
                    window.ReactNativeWebView = {
                        postMessage: function (data) {
                            messageQueue.push(String(data));
                            processQueue();
                        },
                        messageReceived: function () {
                            messagePending = false;
                            processQueue();
                        }
                    };
                })();
            }
        }
        setupWebViewJavascriptBridge(function (bridge) {
            errorMsg += "-- js injected.\n";
            registerJsFuns(bridge, "registerHandler");
            doneBridge(bridge);
        })
    } else if (isUWP || isCommonChannel) {
        // UWP/Electron通信方式
        window.UWPOrElBridge = {
            postMessage: function (data) {
                if (isUWP) {
                    window.external.notify(data);
                } else {
                    var eP = window.__electronPostMessage;
                    eP && eP("sdkMsg", data);
                }
            }
        };
        doneBridge({});
    }

    function addRNCallback(callback, context) {
        var callbackId = ++rnLastCallbackId;
        rnCallbacks["" + callbackId] = { callback: callback, context: context };
        return callbackId;
    }

    function registerJsFuns(bridge, registerName) {
        errorMsg += "-- register Js Funs.\n";
        bridge[registerName]("onPageVisibleChanged", function (data) {
            _onPageVisibleChanged && _onPageVisibleChanged(genObj(data));
        });
        bridge[registerName]("onAppThemeChanged", function (data) {
            resetTheme(genObj(data))
        });
        bridge[registerName]("onOptionMenuClicked", function (data) {
            _optionMenuCB && _optionMenuCB(genObj(data))
        });
        bridge[registerName]('onReceiveMessage', function (data, responseCallback) {
            var info = genObj(data);
            var eventName = info.name;
            if (typeof _listeners[eventName] !== typeof undefined) {
                var callback = null;
                if (responseCallback) {
                    callback = function (res) {
                        responseCallback("object" == typeof res ? JSON.stringify(res) : res + "");
                    }
                }
                _listeners[eventName](info.data, callback);
            }
        })
    }

    function doneBridge(bridge) {
        if (bridge == null) {
            errorMsg += "-- init bridge error(null).\n";
            forceReady();
            return;
        }
        bridgeInternal = bridge;
        callNative = function (bridgename, data, callback) {
            if(bridgename === "showModal" && data && !data.textAlign){
                data.textAlign = data.content && data.content.length >= 12 ? "left" : "center";
            }
            if (!that.isLegalEnv()) {
                callback && callback({ success: false, message: "运行环境非法(005)" });
            } else if (isWxmp()) {
                if (bridgename === "getUserHash" && hash.success) {
                    return callback(hash);
                } else if (bridgename === "encrypt") {
                    return callback(that.encryptSync(data));
                } else if (bridgename === "decrypt") {
                    return callback(that.decryptSync(data));
                } else if (bridgename === "toast") {
                    return window._showToast && window._showToast(data.data, data.duration || 5000);
                }
                callback && callback({ success: false, message: "微信小程序不支持此操作，请使用IT之家App" });
            } else if (isUWP || (isReactNative && rnApis.indexOf(allApiNames.indexOf(bridgename)) !== -1) || isCommonChannel) {
                if (data == null || typeof data == typeof undefined) {
                    data = {};
                }
                var result = data;
                if (isCommonChannel) {
                    result = { name: bridgename, data: data, isInternalApi: true };
                } else if (isUWP || typeof data !== "object" || Array.isArray(data)) {
                    result = { name: "sdk-api-" + bridgename, data: data };
                } else {
                    result.name = "sdk-api-" + bridgename;
                }

                that.sendMessage(result, callback);
            } else if (isAndroid || isIOS || (isMac && !isElectron)) {
                var fName = isAndroid ? "call" : "callHandler";
                if (callback !== null) {
                    bridgeInternal[fName](bridgename, data, function (res) {
                        callback(genObj(res));
                    });
                } else {
                    bridgeInternal[fName](bridgename, data);
                }
            }
        }
        var isSystemReady = false,
            isUserInfoReady = false,
            isHashReady = false;
        if (that.isLegalEnv() && !isWxmp()) {
            // 初始化
            if (!useNewInit) {
                try {
                    callNative("getUserInfo", null, function (res) {
                        userInfo = res;
                        isUserInfoReady = true;
                        checkReady();
                    })
                } catch (error) {
                    isUserInfoReady = true;
                    checkReady();
                    showError("User check failed!");
                }
                try {
                    callNative("getUserHash", null, function (res) {
                        hash = res;
                        isHashReady = true;
                        checkReady();
                    })
                } catch (error) {
                    isHashReady = true;
                    checkReady();
                    showError("Userhash check failed!");
                }
            }
            try {
                callNative("getSystemInfo", { needAuth: true }, function (res) {
                    if (typeof res.systemInfo !== typeof undefined) {
                        res.systemInfo.isWxmp = false;
                    }
                    sysInfo = { success: res.success, systemInfo: res.systemInfo };
                    intent = !!res.intent ? res.intent : null;
                    if (!isEmpty(res.extra)) {
                        secret = res.extra;
                    }
                    isSystemReady = true;
                    if (!!res._userInfo) {
                        userInfo = res._userInfo;
                        isUserInfoReady = true;
                    }
                    if (!!res._userHash) {
                        hash = res._userHash;
                        isHashReady = true;
                    }
                    checkReady();
                })
            } catch (error) {
                isSystemReady = true;
                checkReady();
                showError("System check failed!")
            }
        } else {
            forceReady();
        }
        function forceReady() {
            if (isWxmp()) {
                document.write("<script src='https://dat.ruanmei.com/lib/showToast.js'><\/script>");
                window._parseJSSDKKey = function (key) {
                    secret = window.atob(key);
                    var token = parseUrl(this.window.location.href).params._rmsdktoken;
                    if (!isEmpty(token)) {
                        var info = JSON.parse(that.decryptSync({ text: token }).data);
                        var hashStr = info.__hash;
                        wxAppName = info.__appName || "unknown";
                        delete info.__hash;
                        hash = { success: true, userHash: hashStr };
                        userInfo = { success: true, userInfo: info };
                    }
                    isSystemReady = true;
                    isUserInfoReady = true;
                    isHashReady = true;
                    checkReady();
                }
                document.write("<script src='https://dat.ruanmei.com/lib/rm-js-sdk-key.js'><\/script>");
            } else {
                isSystemReady = true;
                isUserInfoReady = true;
                isHashReady = true;
                checkReady();
            }
        }
        function showError(msg) {
            console.warn("JS-SDK", msg);
        }
        function checkReady() {
            if (!isReady && isSystemReady && isUserInfoReady && isHashReady) {
                isReady = true;
                try {
                    var css = '*{-webkit-tap-highlight-color: rgba(0, 0, 0, 0) !important;}.disable-user-select-ruanmei-sdk * {-webkit-touch-callout:none;-webkit-user-select:none;user-select:none;}pre,input,textarea{-webkit-touch-callout:default;-webkit-user-select:text;user-select:text;}',
                        head = document.head || document.getElementsByTagName('head')[0],
                        style = document.createElement('style');
                    if (sysInfo && sysInfo.systemInfo && sysInfo.systemInfo.userCustomFont) {
                        css += "@font-face{font-family: myFirstFont; src: url('/" + sysInfo.systemInfo.userCustomFont + "') format('truetype')} body *{font-family:myFirstFont,Arial,sans-serif !important;}"
                    }
                    style.type = 'text/css';
                    if (style.styleSheet) {
                        style.styleSheet.cssText = css;
                    } else {
                        style.appendChild(document.createTextNode(css));
                    }
                    head.appendChild(style);
                } catch (e) { }
                readyCallbacks.forEach(function (callback) { callback(); })
            }
        }
    }
    function setupWebViewJavascriptBridge(callback) {
        if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
        if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
        window.WVJBCallbacks = [callback];
        var WVJBIframe = document.createElement('iframe');
        WVJBIframe.style.display = 'none';
        WVJBIframe.src = 'https://__bridge_loaded__';
        document.documentElement.appendChild(WVJBIframe);
        setTimeout(function () { document.documentElement.removeChild(WVJBIframe) }, 0)
    }

    function processRnOrElCallback(data) {
        var result = data;
        var callbackId = result.callbackId;
        delete result.callbackId;
        if (callbackId == -1) {
            _onPageVisibleChanged && _onPageVisibleChanged(genObj(result));
        } else if (callbackId == -2) {
            resetTheme(result)
        } else if (callbackId > -1) {
            var callbackInfo = rnCallbacks["" + callbackId];
            callbackInfo.callback.call(callbackInfo.context, result);
            delete rnCallbacks["" + callbackId];
        }
    }
    function resetTheme(obj) {
        obj.isDark = obj.isNight || obj.isDark;
        if (_onAppThemeChanged !== null) {
            _onAppThemeChanged(obj)
        } else {
            toggleCLass("html", obj.isDark, "night");
            toggleCLass("body", obj.isDark, "night");
        }
    }
    function toggleCLass(tag, isAdd, clazzname) {
        try { document.getElementsByTagName(tag)[0].classList[isAdd ? "add" : "remove"](clazzname); } catch (e) { }
    }
    function getTargetUrl(o) {
        var obj = {};
        Object.keys(o).forEach(function (k) {
            obj[k.toLowerCase().replace(/-/g, "")] = o[k];
        });
        var result = obj.url,
            sName = relation[appStr].s + getPlat().toLowerCase().replace("/", ""),
            fName = relation[appStr].f;
        if (!isEmpty(obj[sName])) {
            result = obj[sName];
        } else if (!isEmpty(obj[fName])) {
            result = obj[fName];
        }
        return getAbsolutePath(result);
    }
    function isEmpty(str) {
        return str == null || typeof str == typeof undefined || str.length == 0;
    }
    function isWxmp() {
        return window.__wxjs_environment === 'miniprogram' || window.navigator.userAgent.indexOf("miniProgram") !== -1;
    }
    function convert2QueryString(content) {
        var addStr = "";
        if (typeof content == "string") {
            var addStr = content;
            while (addStr.length > 1
                && (addStr.indexOf("&") == 0 || addStr.indexOf("?") == 0)) {
                addStr = addStr.substring(1);
            }
        } else if (typeof content == "object") {
            var params = content;
            for (var paramName in params) {
                var paramValue = params[paramName];
                var pair = encodeURIComponent(paramName) + "=" + encodeURIComponent(paramValue);
                addStr += (addStr.length === 0 ? "" : "&") + pair;
            }
        }
        return addStr;
    }
    function getAbsolutePath(href) {
        var link = document.createElement("a");
        link.href = href;
        return link.href;
    }
    function parseUrl(url) {
        var parts = url.split("://");
        var scheme = parts[0];
        var domain = parts[1];
        if (domain.indexOf("/") != -1) {
            domain = domain.split("/")[0];
        }
        if (domain.indexOf("?") !== -1) {
            domain = domain.substring(0, domain.indexOf("?"))
        }
        if (domain.indexOf("#") !== -1) {
            domain = domain.substring(0, domain.indexOf("#"))
        }
        var params = {};
        var key = "",
            value = "";
        var paraString = url.substring(url.indexOf("?") + 1, url.length).split("&");
        for (var i in paraString) {
            var str = paraString[i];
            if (str.indexOf("=") > 0) {
                key = str.substring(0, str.indexOf("="));
                value = str.substring(str.indexOf("=") + 1);
                if (value.indexOf("#") !== -1) {
                    value = value.substring(0, value.indexOf("#"));
                }
                params[key] = decodeURIComponent(value);
            }
        }
        return {
            scheme: scheme.toLowerCase(),
            host: domain.toLowerCase(),
            params: params
        };
    }
    function _ajax(opt, calback) {
        opt = opt || {};
        opt.method = (opt.method || 'POST').toUpperCase();
        opt.url = opt.url || '';
        opt.async = opt.async || true;
        opt.data = opt.data || null;
        opt.callback = calback || function () { };
        var xmlHttp = null;
        if (XMLHttpRequest) {
            xmlHttp = new XMLHttpRequest();
        } else {
            xmlHttp = new ActiveXObject('Microsoft.XMLHTTP');
        }
        xmlHttp.open(opt.method, opt.url, opt.async);
        for (var paramName in opt.header) {
            var paramValue = opt.header[paramName];
            xmlHttp.setRequestHeader(paramName, paramValue);
        }
        xmlHttp.send(opt.method.toUpperCase() === 'POST' ? opt.data : null);
        xmlHttp.onreadystatechange = function () {
            if (xmlHttp.readyState == 4) {
                var code = xmlHttp.status;
                // 加上header
                opt.callback({ statusCode: code, data: (code >= 200 && code < 300) ? genObj(xmlHttp.responseText) : null });
            }
        };
    }
    function genObj(data) {
        var result = data;
        try { result = typeof data == "object" ? data : JSON.parse(data) } catch (e) { result = data }
        return result;
    }
    function is(s) {
        return relation[appStr].s === s || relation[appStr].f === s;
    }
    function getPlat() {
        var platform = "unknown";
        if (isAndroid) {
            platform = "Android";
        } else if (isIOS) {
            platform = "iOS";
        } else if (isUWP) {
            platform = "UWP";
        } else if (isElectron) {
            platform = "Electron";
            if (UA.indexOf("macOS") !== -1) {
                platform += "/macOS";
            } else if (UA.indexOf("win32") !== -1) {
                platform += "/win32";
            } else if (UA.indexOf("linux") !== -1) {
                platform += "/linux";
            }
        } else if (isMac) {
            platform = "macOS";
        } else if (isWin) {
            platform = "windows"
        }
        return platform;
    }
    function getArgs(args) {
        var callback = null;
        var data = null;
        for (var i = 0; i < args.length; i++) {
            if (typeof args[i] === "function") {
                callback = args[i];
            } else if (typeof args[i] !== typeof undefined) {
                data = args[i];
            }
        }
        return [data, callback];
    }
}

const rm = new RuanmeiJsFunctions();